From 61fff62c2a1f35398ae93b333a963c73580d2189 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Fri, 6 Sep 2019 17:35:47 +0200
Subject: [PATCH] WIP utmp removal 20190906

---
 Makefile_upgrade.inc                          |  10 +
 bin/csh/csh/config.h                          |  10 +-
 bin/date/Makefile                             |   1 -
 bin/date/date.c                               |  12 -
 include/Makefile                              |   2 +-
 include/unistd.h                              |   1 -
 include/utmp.h                                |  72 ---
 include/utmpx.h                               |   3 +-
 lib/libc/Versions.def                         |   6 +-
 lib/libc/gen/Makefile.inc                     |   8 +-
 lib/libc/gen/Symbol.map                       |  13 +-
 lib/libc/gen/endutxent.3                      |  14 +
 lib/libc/gen/getlastlogx.3                    |  25 -
 lib/libc/gen/getttyent.3                      |   1 -
 lib/libc/gen/ttyname.3                        |  23 +-
 lib/libc/gen/ttyslot.c                        |  32 +-
 lib/libc/gen/utmp.c                           |  64 +--
 lib/libc/gen/utmpx.c                          |  51 +-
 lib/libpam/modules/pam_lastlog/pam_lastlog.c  |  89 ---
 lib/libssh/config.h                           |  30 +-
 lib/libutil/Makefile                          |   4 +-
 lib/libutil/libutil.h                         |   3 -
 lib/libutil/login.3                           |  65 ---
 lib/libutil/logout.3                          |  67 ---
 lib/libutil/logout.c                          |  67 ---
 lib/libutil/logwtmp.3                         |  71 ---
 lib/libutil/logwtmp.c                         |  98 ----
 libexec/comsat/Makefile                       |   2 +-
 libexec/comsat/comsat.8                       |   7 +-
 libexec/comsat/comsat.c                       | 130 ++---
 libexec/ftpd/logwtmp.c                        |  60 +-
 libexec/getty/ttys.5                          |   1 -
 .../login.c => libexec/rpc.rusersd/extern.h   |  35 +-
 libexec/rpc.rusersd/rpc.rusersd.8             |   5 +-
 libexec/rpc.rusersd/rusers_proc.c             | 216 +++-----
 libexec/rpc.rusersd/rusersd.c                 |  32 +-
 libexec/talkd/Makefile                        |   2 +-
 libexec/telnetd/Makefile                      |   3 +-
 libexec/telnetd/sys_term.c                    |   8 -
 libexec/telnetd/telnetd.8                     |  18 +-
 libexec/telnetd/telnetd.c                     |  24 -
 sbin/init/Makefile                            |   1 -
 sbin/init/init.c                              |  30 -
 sbin/reboot/Makefile                          |   1 -
 sbin/reboot/reboot.c                          |   7 -
 share/man/man5/Makefile                       |   3 -
 share/man/man5/utmp.5                         | 267 ---------
 share/man/man5/utmpx.5                        |   1 +
 sys/sys/param.h                               |   6 +-
 usr.bin/Makefile                              |   1 +
 usr.bin/finger/Makefile                       |   2 +-
 usr.bin/finger/lprint.c                       |   2 -
 usr.bin/finger/net.c                          |   1 -
 usr.bin/finger/sprint.c                       |   7 +-
 usr.bin/finger/util.c                         |  47 +-
 usr.bin/last/Makefile                         |   2 +-
 usr.bin/last/last.c                           | 263 ++++++---
 usr.bin/last/want.c                           | 223 --------
 usr.bin/systat/Makefile                       |   2 +-
 usr.bin/users/Makefile                        |   2 +-
 usr.bin/w/Makefile                            |   1 -
 usr.bin/w/w.c                                 |  80 +--
 usr.bin/wall/Makefile                         |   2 +-
 usr.bin/who/Makefile                          |   4 -
 usr.bin/who/utmpentry.c                       | 131 -----
 usr.bin/who/utmpentry.h                       |  17 +-
 usr.bin/who/who.c                             |   7 -
 usr.bin/write/Makefile                        |   2 +-
 usr.bin/wtmpcvt/Makefile                      |   5 +
 usr.bin/wtmpcvt/wtmpcvt.1                     |  66 +++
 usr.bin/wtmpcvt/wtmpcvt.c                     | 139 +++++
 usr.sbin/ac/Makefile                          |   2 +-
 usr.sbin/ac/ac.8                              |  54 +-
 usr.sbin/ac/ac.c                              | 513 +++++++++---------
 usr.sbin/adduser/adduser.8                    |   8 -
 usr.sbin/lastlogin/lastlogin.c                |  60 +-
 usr.sbin/ppp/id.c                             |  36 +-
 usr.sbin/ppp/id.h                             |  23 +-
 usr.sbin/ppp/physical.c                       |  27 +-
 usr.sbin/rwhod/rwhod.c                        |  82 +--
 usr.sbin/sshd/Makefile                        |   2 +-
 81 files changed, 1061 insertions(+), 2453 deletions(-)
 delete mode 100644 include/utmp.h
 delete mode 100644 lib/libutil/login.3
 delete mode 100644 lib/libutil/logout.3
 delete mode 100644 lib/libutil/logout.c
 delete mode 100644 lib/libutil/logwtmp.3
 delete mode 100644 lib/libutil/logwtmp.c
 rename lib/libutil/login.c => libexec/rpc.rusersd/extern.h (67%)
 delete mode 100644 share/man/man5/utmp.5
 delete mode 100644 usr.bin/last/want.c
 create mode 100644 usr.bin/wtmpcvt/Makefile
 create mode 100644 usr.bin/wtmpcvt/wtmpcvt.1
 create mode 100644 usr.bin/wtmpcvt/wtmpcvt.c

diff --git a/Makefile_upgrade.inc b/Makefile_upgrade.inc
index 218ecc8510..0be7fcb258 100644
--- a/Makefile_upgrade.inc
+++ b/Makefile_upgrade.inc
@@ -3756,6 +3756,16 @@ TO_REMOVE+=/usr/sbin/rdate
 TO_REMOVE+=/usr/share/man/man8/rdate.8.gz
 TO_REMOVE+=/entropy
 TO_REMOVE+=/usr/share/man/man9/kmalloc_cachealign.9.gz
+TO_REMOVE+=/usr/include/utmp.h
+TO_REMOVE+=/usr/share/man/man3/getutmp.3.gz
+TO_REMOVE+=/usr/share/man/man3/getutmpx.3.gz
+TO_REMOVE+=/usr/share/man/man3/login.3.gz
+TO_REMOVE+=/usr/share/man/man3/logout.3.gz
+TO_REMOVE+=/usr/share/man/man3/logwtmp.3.gz
+TO_REMOVE+=/usr/share/man/man5/lastlog.5.gz
+TO_REMOVE+=/usr/share/man/man5/utmp.5.gz
+TO_REMOVE+=/usr/share/man/man5/wtmp.5.gz
+TO_REMOVE+=/usr/share/man/man3/ttyslot.3.gz
 
 .if !defined(WANT_INSTALLER)
 TO_REMOVE+=/usr/sbin/dfuibe_installer
diff --git a/bin/csh/csh/config.h b/bin/csh/csh/config.h
index 150e32eb5d..e619bb3ff1 100644
--- a/bin/csh/csh/config.h
+++ b/bin/csh/csh/config.h
@@ -150,16 +150,16 @@
 #define HAVE_STRUCT_UTMPX_UT_XTIME 1
 
 /* Define to 1 if `ut_host' is a member of `struct utmp'. */
-#define HAVE_STRUCT_UTMP_UT_HOST 1
+/* #undef HAVE_STRUCT_UTMP_UT_HOST */
 
 /* Define to 1 if `ut_tv' is a member of `struct utmp'. */
-#define HAVE_STRUCT_UTMP_UT_TV 1
+/* #undef HAVE_STRUCT_UTMP_UT_TV */
 
 /* Define to 1 if `ut_user' is a member of `struct utmp'. */
-#define HAVE_STRUCT_UTMP_UT_USER 1
+/* #undef HAVE_STRUCT_UTMP_UT_USER */
 
 /* Define to 1 if `ut_xtime' is a member of `struct utmp'. */
-#define HAVE_STRUCT_UTMP_UT_XTIME 1
+/* #undef HAVE_STRUCT_UTMP_UT_XTIME */
 
 /* Define to 1 if you have the `sysconf' function. */
 #define HAVE_SYSCONF 1
@@ -185,7 +185,7 @@
 #define HAVE_UTMPX_H 1
 
 /* Define to 1 if you have the <utmp.h> header file. */
-#define HAVE_UTMP_H 1
+/* #undef HAVE_UTMP_H */
 
 /* Define to 1 if you have the <wchar.h> header file. */
 #define HAVE_WCHAR_H 1
diff --git a/bin/date/Makefile b/bin/date/Makefile
index 525eacbd6d..8f51898d23 100644
--- a/bin/date/Makefile
+++ b/bin/date/Makefile
@@ -3,7 +3,6 @@
 
 PROG=	date
 SRCS=	date.c vary.c
-CFLAGS+=-DSUPPORT_UTMP -DSUPPORT_UTMPX
 
 DPADD=	${LIBUTIL}
 LDADD=	-lutil
diff --git a/bin/date/date.c b/bin/date/date.c
index 63384b43b0..5df335228f 100644
--- a/bin/date/date.c
+++ b/bin/date/date.c
@@ -43,9 +43,7 @@
 #include <unistd.h>
 #include <locale.h>
 #include <libutil.h>
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
-#endif
 
 #include "vary.h"
 
@@ -255,22 +253,12 @@ setthetime(const char *fmt, const char *p, int jflag)
 		errx(1, "nonexistent time");
 
 	if (!jflag) {
-#ifdef SUPPORT_UTMP
-		logwtmp("|", "date", "");
-#endif
-#ifdef SUPPORT_UTMPX
 		logwtmpx("|", "date", "", 0, OLD_TIME);
-#endif
 		tv.tv_sec = tval;
 		tv.tv_usec = 0;
 		if (settimeofday(&tv, NULL))
 			err(1, "settimeofday (timeval)");
-#ifdef SUPPORT_UTMP
-		logwtmp("{", "date", "");
-#endif
-#ifdef SUPPORT_UTMPX
 		logwtmpx("{", "date", "", 0, NEW_TIME);
-#endif
 
 		if ((p = getlogin()) == NULL)
 			p = "???";
diff --git a/include/Makefile b/include/Makefile
index 564cf02a73..0fbe3ca861 100644
--- a/include/Makefile
+++ b/include/Makefile
@@ -26,7 +26,7 @@ INCS=	a.out.h alloca.h ar.h assert.h bitstring.h cpio.h ctype.h db.h \
 	tar.h termios.h time.h \
 	timeconv.h \
 	timers.h ttyent.h \
-	uchar.h unistd.h ulimit.h utime.h utmp.h utmpx.h \
+	uchar.h unistd.h ulimit.h utime.h utmpx.h \
 	uuid.h vis.h \
 	wchar.h wctype.h wordexp.h xlocale.h
 
diff --git a/include/unistd.h b/include/unistd.h
index 6c6482bf6a..b6e6e81e39 100644
--- a/include/unistd.h
+++ b/include/unistd.h
@@ -596,7 +596,6 @@ int	 swapoff(const char *);
 int	 swapon(const char *);
 int	 syscall(int, ...);
 off_t	 __syscall(quad_t, ...);
-int	 ttyslot(void);
 int	 umtx_sleep(volatile const int *, int , int);
 int	 umtx_wakeup(volatile const int *, int);
 int	 undelete(const char *);
diff --git a/include/utmpx.h b/include/utmpx.h
index 836b211e6f..eea46ea69d 100644
--- a/include/utmpx.h
+++ b/include/utmpx.h
@@ -139,9 +139,8 @@ void updwtmpx(const char *, const struct utmpx *);
 struct lastlogx *getlastlogx(const char *, uid_t, struct lastlogx *);
 int updlastlogx(const char *, uid_t, struct lastlogx *);
 struct utmp;
-void getutmp(const struct utmpx *, struct utmp *);
-void getutmpx(const struct utmp *, struct utmpx *);
 int utmpxname(const char *);
+struct utmpx *getutxuser(const char *);
 int setutxdb(utx_db_t, const char *);
 #endif
 __END_DECLS
diff --git a/lib/libc/Versions.def b/lib/libc/Versions.def
index c97a1b3327..cce3fc43be 100644
--- a/lib/libc/Versions.def
+++ b/lib/libc/Versions.def
@@ -45,6 +45,10 @@ DF504.0 {
 DF506.0 {
 } DF504.0;
 
+# version for DragonFly 5.7
+DF508.0 {
+} DF506.0;
+
 # This is our private namespace.  Any global interfaces that are
 # strictly for use only by other DragonFly applications and libraries
 # are listed here.  We use a separate namespace so we can write
@@ -52,4 +56,4 @@ DF506.0 {
 #
 # Please do NOT increment the version of this namespace.
 DFprivate_1.0 {
-} DF506.0;
+} DF508.0;
diff --git a/lib/libc/gen/Makefile.inc b/lib/libc/gen/Makefile.inc
index 08bdf7cf2a..32176113ba 100644
--- a/lib/libc/gen/Makefile.inc
+++ b/lib/libc/gen/Makefile.inc
@@ -105,6 +105,7 @@ MLINKS+=dlsym.3 dlfunc.3
 MLINKS+=endutxent.3 getutxent.3 \
 	endutxent.3 getutxid.3 \
 	endutxent.3 getutxline.3 \
+	endutxent.3 getutxuser.3 \
 	endutxent.3 pututxline.3 \
 	endutxent.3 setutxdb.3 \
 	endutxent.3 setutxent.3
@@ -169,9 +170,7 @@ MLINKS+=getgrent.3 endgrent.3 \
 	getgrent.3 setgroupent.3
 MLINKS+=gethostid.3 sethostid.3
 MLINKS+=gethostname.3 sethostname.3
-MLINKS+=getlastlogx.3 getutmp.3 \
-	getlastlogx.3 getutmpx.3 \
-	getlastlogx.3 updlastlogx.3 \
+MLINKS+=getlastlogx.3 updlastlogx.3 \
 	getlastlogx.3 _updwtmpx.3 \
 	getlastlogx.3 updwtmpx.3 \
 	getlastlogx.3 utmpxname.3
@@ -284,8 +283,7 @@ MLINKS+=tcsetattr.3 cfgetispeed.3 \
 	tcsetattr.3 cfsetspeed.3 \
 	tcsetattr.3 tcgetattr.3
 MLINKS+=ttyname.3 isatty.3 \
-	ttyname.3 ttyname_r.3 \
-	ttyname.3 ttyslot.3
+	ttyname.3 ttyname_r.3
 MLINKS+=tzset.3 tzsetwall.3
 MLINKS+=unvis.3 strnunvis.3 \
 	unvis.3 strnunvisx.3 \
diff --git a/lib/libc/gen/ttyslot.c b/lib/libc/gen/ttyslot.c
index 2aa46b3cf6..c0ee1af23a 100644
--- a/lib/libc/gen/ttyslot.c
+++ b/lib/libc/gen/ttyslot.c
@@ -27,39 +27,13 @@
  * SUCH DAMAGE.
  *
  * @(#)ttyslot.c	8.1 (Berkeley) 6/4/93
- * $DragonFly: src/lib/libc/gen/ttyslot.c,v 1.4 2005/11/13 00:07:42 swildner Exp $
  */
 
-#include <paths.h>
-#include <ttyent.h>
-#include <stdio.h>
-#include <string.h>
-#include <unistd.h>
+#include <sys/cdefs.h>
 
+__sym_compat(ttyslot, past_ttyslot, DF404.0);
 int
-ttyslot(void)
+past_ttyslot(void)
 {
-	struct ttyent *ttyp;
-	int slot;
-	int cnt;
-	char *name;
-	size_t len = sizeof(_PATH_DEV) - 1;
-
-	setttyent();
-	for (cnt = 0; cnt < 3; ++cnt)
-		if ( (name = ttyname(cnt)) ) {
-			if (strncmp(name, _PATH_DEV, len) != 0)
-				break;
-
-			name += len;
-
-			for (slot = 1; (ttyp = getttyent()); ++slot)
-				if (!strcmp(ttyp->ty_name, name)) {
-					endttyent();
-					return(slot);
-				}
-			break;
-		}
-	endttyent();
 	return(0);
 }
diff --git a/lib/libc/gen/utmp.c b/lib/libc/gen/utmp.c
index 6b24a450eb..09819673e8 100644
--- a/lib/libc/gen/utmp.c
+++ b/lib/libc/gen/utmp.c
@@ -29,74 +29,30 @@
  * POSSIBILITY OF SUCH DAMAGE.
  */
 
-#include "namespace.h"
-#include <sys/types.h>
 #include <sys/param.h>
-#include <stdio.h>
-#include <string.h>
-#include <time.h>
-#include <utmp.h>
-#include <sys/stat.h>
-#include "un-namespace.h"
-
-static struct utmp utmp;
-static FILE *ut;
-static char utfile[MAXPATHLEN] = _PATH_UTMP;
 
+__sym_compat(setutent, past_setutent, DF404.0);
 void
-setutent(void)
+past_setutent(void)
 {
-	if (ut == NULL)
-		return;
-	(void)fseeko(ut, (off_t)0, SEEK_SET);
 }
 
-struct utmp *
-getutent(void)
+__sym_compat(getutent, past_getutent, DF404.0);
+void *
+past_getutent(void)
 {
-	if (ut == NULL) {
-		struct stat st;
-		off_t numentries;
-		if ((ut = fopen(utfile, "r")) == NULL)
-			return NULL;
-		if (_fstat(fileno(ut), &st) == -1)
-			goto out;
-		/*
-		 * If we have a an old version utmp file bail.
-		 */
-		numentries = st.st_size / sizeof(utmp);
-		if ((off_t)(numentries * sizeof(utmp)) != st.st_size)
-			goto out;
-	}
-	if (fread(&utmp, sizeof(utmp), 1, ut) == 1)
-		return &utmp;
-out:
-	(void)fclose(ut);
 	return NULL;
 }
 
+__sym_compat(endutent, past_endutent, DF404.0);
 void
-endutent(void)
+past_endutent(void)
 {
-	if (ut != NULL) {
-		(void)fclose(ut);
-		ut = NULL;
-	}
 }
 
+__sym_compat(utmpname, past_utmpname, DF404.0);
 int
-utmpname(const char *fname)
+past_utmpname(const char *fname)
 {
-	size_t len = strlen(fname);
-
-	if (len >= sizeof(utfile))
-		return 0;
-
-	/* must not end in x! */
-	if (fname[len - 1] == 'x')
-		return 0;
-
-	(void)strlcpy(utfile, fname, sizeof(utfile));
-	endutent();
-	return 1;
+	return 0;
 }
diff --git a/lib/libc/gen/utmpx.c b/lib/libc/gen/utmpx.c
index 759658e2be..05db6e61a2 100644
--- a/lib/libc/gen/utmpx.c
+++ b/lib/libc/gen/utmpx.c
@@ -44,7 +44,6 @@
 #include <string.h>
 #include <unistd.h>
 #include <pwd.h>
-#include <utmp.h>
 #include <utmpx.h>
 #include <vis.h>
 
@@ -240,6 +239,26 @@ getutxline(const struct utmpx *utx)
 	return NULL;
 }
 
+struct utmpx *
+getutxuser(const char *user)
+{
+	_DIAGASSERT(utx != NULL);
+
+	do {
+		switch (ut.ut_type) {
+		case EMPTY:
+			break;
+		case USER_PROCESS:
+			if (strncmp(ut.ut_user, user, sizeof(ut.ut_user)) == 0)
+				return &ut;
+			break;
+		default:
+			break;
+		}
+	} while (getutxent() != NULL);
+	return NULL;
+}
+
 struct utmpx *
 pututxline(const struct utmpx *utx)
 {
@@ -406,37 +425,17 @@ utmpxname(const char *fname)
 	return 1;
 }
 
+
+__sym_compat(getutmp, past_getutmp, DF404.0);
 void
-getutmp(const struct utmpx *ux, struct utmp *u)
+past_getutmp(void *ux, void *u)
 {
-
-	_DIAGASSERT(ux != NULL);
-	_DIAGASSERT(u != NULL);
-
-	(void)memcpy(u->ut_name, ux->ut_name, sizeof(u->ut_name));
-	(void)memcpy(u->ut_line, ux->ut_line, sizeof(u->ut_line));
-	(void)memcpy(u->ut_host, ux->ut_host, sizeof(u->ut_host));
-	u->ut_time = ux->ut_tv.tv_sec;
 }
 
+__sym_compat(getutmpx, past_getutmpx, DF404.0);
 void
-getutmpx(const struct utmp *u, struct utmpx *ux)
+past_getutmpx(void *u, void *ux)
 {
-
-	_DIAGASSERT(ux != NULL);
-	_DIAGASSERT(u != NULL);
-
-	(void)memcpy(ux->ut_name, u->ut_name, sizeof(u->ut_name));
-	(void)memcpy(ux->ut_line, u->ut_line, sizeof(u->ut_line));
-	(void)memcpy(ux->ut_host, u->ut_host, sizeof(u->ut_host));
-	ux->ut_tv.tv_sec = u->ut_time;
-	ux->ut_tv.tv_usec = 0;
-	(void)memset(&ux->ut_ss, 0, sizeof(ux->ut_ss));
-	ux->ut_pid = 0;
-	ux->ut_type = USER_PROCESS;
-	ux->ut_session = 0;
-	ux->ut_exit.e_termination = 0;
-	ux->ut_exit.e_exit = 0;
 }
 
 struct lastlogx *
diff --git a/lib/libpam/modules/pam_lastlog/pam_lastlog.c b/lib/libpam/modules/pam_lastlog/pam_lastlog.c
index 983807e1e1..cd3561fa6b 100644
--- a/lib/libpam/modules/pam_lastlog/pam_lastlog.c
+++ b/lib/libpam/modules/pam_lastlog/pam_lastlog.c
@@ -64,30 +64,13 @@
 #include <security/pam_modules.h>
 #include <security/pam_mod_misc.h>
 
-#define SUPPORT_UTMP 1
-#define SUPPORT_UTMPX 1
-
-#ifdef SUPPORT_UTMP
-#include <utmp.h>
-static void doutmp(const char *, const char *, const char *,
-    const struct timeval *);
-static void dolastlog(pam_handle_t *, int, const struct passwd *, const char *,
-    const char *, const struct timeval *);
-#endif
-
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
 static void doutmpx(const char *, const char *, const char *,
     const struct sockaddr_storage *ss, const struct timeval *);
 static void dolastlogx(pam_handle_t *, int, const struct passwd *, const char *,
     const char *, const struct sockaddr_storage *ss, const struct timeval *);
-#endif
-
-#if defined(SUPPORT_UTMPX) || defined(SUPPORT_UTMP)
 static void domsg(pam_handle_t *, time_t, const char *, size_t, const char *,
     size_t);
-#endif
-
 static void logit(int, const char *, ...) __printflike(2, 3);
 
 static void
@@ -166,15 +149,9 @@ pam_sm_open_session(pam_handle_t *pamh, int flags,
 		quiet = 0;
 #endif
 	}
-#ifdef SUPPORT_UTMPX
 	dolastlogx(pamh, quiet, pwd, rhost, tty, NULL, &now);
 	doutmpx(user, rhost, tty, NULL, &now);
 	quiet = 1;
-#endif
-#ifdef SUPPORT_UTMP
-	doutmp(user, rhost, tty, &now);
-	dolastlog(pamh, quiet, pwd, rhost, tty, &now);
-#endif
 err:
 	if (openpam_get_option(pamh, "no_fail"))
 		return PAM_SUCCESS;
@@ -199,25 +176,15 @@ pam_sm_close_session(pam_handle_t *pamh __unused, int flags __unused,
 	if (*tty == '\0')
 		return PAM_SERVICE_ERR;
 
-#ifdef SUPPORT_UTMPX
 	if (logoutx(tty, 0, DEAD_PROCESS))
 		logwtmpx(tty, "", "", 0, DEAD_PROCESS);
 	else
 		logit(LOG_NOTICE, "%s(): no utmpx record for %s",
 		    __func__, tty);
-#endif
 
-#ifdef SUPPORT_UTMP
-	if (logout(tty))
-		logwtmp(tty, "", "");
-	else
-		logit(LOG_NOTICE, "%s(): no utmp record for %s",
-		    __func__, tty);
-#endif
         return PAM_SUCCESS;
 }
 
-#if defined(SUPPORT_UTMPX) || defined(SUPPORT_UTMP)
 static void
 domsg(pam_handle_t *pamh, time_t t, const char *host, size_t hsize,
     const char *line, size_t lsize)
@@ -237,9 +204,7 @@ domsg(pam_handle_t *pamh, time_t t, const char *host, size_t hsize,
 	if (pam_err == PAM_SUCCESS && promptresp)
 		free(promptresp);
 }
-#endif
 
-#ifdef SUPPORT_UTMPX
 static void
 doutmpx(const char *username, const char *hostname, const char *tty,
     const struct sockaddr_storage *ss, const struct timeval *now)
@@ -304,59 +269,5 @@ dolastlogx(pam_handle_t *pamh, int quiet, const struct passwd *pwd,
 	PAM_LOG("Login recorded in %s", _PATH_LASTLOGX);
 #endif
 }
-#endif
-
-#ifdef SUPPORT_UTMP
-static void
-doutmp(const char *username, const char *hostname, const char *tty,
-    const struct timeval *now)
-{
-	struct utmp utmp;
-
-	(void)memset((void *)&utmp, 0, sizeof(utmp));
-	utmp.ut_time = now->tv_sec;
-	(void)strncpy(utmp.ut_name, username, sizeof(utmp.ut_name));
-	if (hostname)
-		(void)strncpy(utmp.ut_host, hostname, sizeof(utmp.ut_host));
-	(void)strncpy(utmp.ut_line, tty, sizeof(utmp.ut_line));
-	login(&utmp);
-}
-
-static void
-dolastlog(pam_handle_t *pamh, int quiet, const struct passwd *pwd,
-    const char *hostname, const char *tty, const struct timeval *now)
-{
-	struct lastlog ll;
-	int fd;
-
-	if ((fd = open(_PATH_LASTLOG, O_RDWR, 0)) == -1) {
-		logit(LOG_NOTICE, "Cannot open `%s' %m", _PATH_LASTLOG);
-		return;
-	}
-	(void)lseek(fd, (off_t)(pwd->pw_uid * sizeof(ll)), SEEK_SET);
-
-	if (!quiet) {
-		if (read(fd, (char *)&ll, sizeof(ll)) == sizeof(ll) &&
-		    ll.ll_time != 0)
-			domsg(pamh, ll.ll_time, ll.ll_host,
-			    sizeof(ll.ll_host), ll.ll_line,
-			    sizeof(ll.ll_line));
-		(void)lseek(fd, (off_t)(pwd->pw_uid * sizeof(ll)), SEEK_SET);
-	}
-
-	ll.ll_time = now->tv_sec;
-	(void)strncpy(ll.ll_line, tty, sizeof(ll.ll_line));
-
-	if (hostname)
-		(void)strncpy(ll.ll_host, hostname, sizeof(ll.ll_host));
-	else
-		(void)memset(ll.ll_host, 0, sizeof(ll.ll_host));
-
-	(void)write(fd, &ll, sizeof(ll));
-	(void)close(fd);
-
-	PAM_LOG("Login recorded in %s", _PATH_LASTLOG);
-}
-#endif
 
 PAM_MODULE_ENTRY("pam_lastlog");
diff --git a/lib/libssh/config.h b/lib/libssh/config.h
index f5a154417c..39f4c99214 100644
--- a/lib/libssh/config.h
+++ b/lib/libssh/config.h
@@ -95,13 +95,13 @@
 /* #undef CONF_LASTLOG_FILE */
 
 /* Define if you want to specify the path to your utmp file */
-#define CONF_UTMP_FILE "/var/run/utmp"
+/* #undef CONF_UTMP_FILE */
 
 /* Define if you want to specify the path to your wtmpx file */
-/* #undef CONF_WTMPX_FILE */
+#define CONF_WTMPX_FILE "/var/log/wtmpx"
 
 /* Define if you want to specify the path to your wtmp file */
-#define CONF_WTMP_FILE "/var/log/wtmp"
+/* #undef CONF_WTMP_FILE */
 
 /* Define if your platform needs to skip post auth file descriptor passing */
 /* #undef DISABLE_FD_PASSING */
@@ -110,7 +110,7 @@
 /* #undef DISABLE_LASTLOG */
 
 /* Define if you don't want to use your system's login() call */
-/* #undef DISABLE_LOGIN */
+#define DISABLE_LOGIN 1
 
 /* Define if you don't want to use pututline() etc. to write [uw]tmp */
 /* #undef DISABLE_PUTUTLINE */
@@ -122,16 +122,16 @@
 /* #undef DISABLE_SHADOW */
 
 /* Define if you don't want to use utmp */
-/* #undef DISABLE_UTMP */
+#define DISABLE_UTMP 1
 
 /* Define if you don't want to use utmpx */
 /* #undef DISABLE_UTMPX */
 
 /* Define if you don't want to use wtmp */
-/* #undef DISABLE_WTMP */
+#define DISABLE_WTMP 1
 
 /* Define if you don't want to use wtmpx */
-#define DISABLE_WTMPX 1
+/* #undef DISABLE_WTMPX */
 
 /* Enable for PKCS#11 support */
 /* #undef ENABLE_PKCS11 */
@@ -662,7 +662,7 @@
 #define HAVE_GETTTYENT 1
 
 /* Define to 1 if you have the `getutent' function. */
-#define HAVE_GETUTENT 1
+/* #undef HAVE_GETUTENT */
 
 /* Define to 1 if you have the `getutid' function. */
 /* #undef HAVE_GETUTID */
@@ -680,7 +680,7 @@
 #define HAVE_GETUTXLINE 1
 
 /* Define to 1 if you have the `getutxuser' function. */
-/* #undef HAVE_GETUTXUSER */
+#define HAVE_GETUTXUSER 1
 
 /* Define to 1 if you have the `get_default_context_with_level' function. */
 /* #undef HAVE_GET_DEFAULT_CONTEXT_WITH_LEVEL */
@@ -719,7 +719,7 @@
 #define HAVE_HMAC_CTX_INIT 1
 
 /* Define if you have ut_host in utmp.h */
-#define HAVE_HOST_IN_UTMP 1
+/* #undef HAVE_HOST_IN_UTMP */
 
 /* Define if you have ut_host in utmpx.h */
 #define HAVE_HOST_IN_UTMPX 1
@@ -848,7 +848,7 @@
 #define HAVE_LOCALE_H 1
 
 /* Define to 1 if you have the `login' function. */
-#define HAVE_LOGIN 1
+/* #undef HAVE_LOGIN */
 
 /* Define to 1 if you have the <login_cap.h> header file. */
 #define HAVE_LOGIN_CAP_H 1
@@ -863,7 +863,7 @@
 #define HAVE_LOGOUT 1
 
 /* Define to 1 if you have the `logwtmp' function. */
-#define HAVE_LOGWTMP 1
+/* #undef HAVE_LOGWTMP */
 
 /* Define to 1 if the system has the type `long double'. */
 #define HAVE_LONG_DOUBLE 1
@@ -1469,7 +1469,7 @@
 #define HAVE_TIME_H 1
 
 /* Define if you have ut_time in utmp.h */
-#define HAVE_TIME_IN_UTMP 1
+/* #undef HAVE_TIME_IN_UTMP */
 
 /* Define if you have ut_time in utmpx.h */
 /* #undef HAVE_TIME_IN_UTMPX */
@@ -1544,7 +1544,7 @@
 #define HAVE_UTIME_H 1
 
 /* Define to 1 if you have the `utmpname' function. */
-#define HAVE_UTMPNAME 1
+/* #undef HAVE_UTMPNAME */
 
 /* Define to 1 if you have the `utmpxname' function. */
 #define HAVE_UTMPXNAME 1
@@ -1553,7 +1553,7 @@
 #define HAVE_UTMPX_H 1
 
 /* Define to 1 if you have the <utmp.h> header file. */
-#define HAVE_UTMP_H 1
+/* #undef HAVE_UTMP_H */
 
 /* define if you have u_char data type */
 #define HAVE_U_CHAR 1
diff --git a/lib/libutil/Makefile b/lib/libutil/Makefile
index 6736f7fb8a..40c750adbb 100644
--- a/lib/libutil/Makefile
+++ b/lib/libutil/Makefile
@@ -6,7 +6,7 @@ SHLIB_MAJOR= 4
 SHLIBDIR?= /lib
 CFLAGS+=-DINET6
 CFLAGS+=-D_CTYPE_H_DISABLE_MACROS_ 
-SRCS=	flopen.c login.c login_tty.c logout.c logwtmp.c logwtmpx.c pty.c \
+SRCS=	flopen.c login_tty.c logwtmpx.c pty.c \
 	login_cap.c login_class.c login_auth.c login_times.c login_ok.c \
 	login_crypt.c loginx.c logoutx.c _secure_path.c uucplock.c \
 	property.c auth.c \
@@ -20,7 +20,7 @@ INCSLINKS=libutil.h ${INCLUDEDIR}/util.h
 
 CFLAGS+= -I${.CURDIR} -I${.CURDIR}/../libc/gen/
 
-MAN+=	flopen.3 login.3 loginx.3 login_auth.3 login_tty.3 logout.3 logwtmp.3 \
+MAN+=	flopen.3 loginx.3 login_auth.3 login_tty.3 \
 	pty.3 \
 	login_cap.3 login_class.3 login_times.3 login_ok.3 \
 	_secure_path.3 uucplock.3 property.3 auth.3 realhostname.3 \
diff --git a/lib/libutil/libutil.h b/lib/libutil/libutil.h
index aecac9c338..7cfbbaf4ca 100644
--- a/lib/libutil/libutil.h
+++ b/lib/libutil/libutil.h
@@ -67,12 +67,9 @@ struct utmpx;
 
 __BEGIN_DECLS
 char	*auth_getval(const char *_name);
-void	login(struct utmp *);
 void	loginx(const struct utmpx *);
 int	login_tty(int);
-int	logout(const char *);
 int	logoutx(const char *, int, int);
-void	logwtmp(const char *, const char *, const char *);
 void	logwtmpx(const char *, const char *, const char *, int, int);
 void	trimdomain(char *, int);
 int	flopen(const char *_path, int _flags, ...);
diff --git a/libexec/comsat/Makefile b/libexec/comsat/Makefile
index a5fe059e4c..151c2edaea 100644
--- a/libexec/comsat/Makefile
+++ b/libexec/comsat/Makefile
@@ -1,5 +1,5 @@
 #	@(#)Makefile	8.1 (Berkeley) 6/4/93
-# $FreeBSD: src/libexec/comsat/Makefile,v 1.6.2.1 2001/04/25 10:40:50 ru Exp $
+# $FreeBSD: head/libexec/comsat/Makefile 74814 2001-03-26 14:22:12Z ru $
 
 PROG=	comsat
 MAN=	comsat.8
